unit chpos;
{$WEAKPACKAGEUNIT ON}
{$J-} //no-writeableconst
{$R-} //no-rangechecking
{$Q-} //no-overflowchecking
{.$D-}//no-debug

// *fast* charpos unit
// extracted originally from unit cxpos ver 2.0.1.5
// search/pos character centrist (works also for repeated char)
// intended for extensive, heavy use
//
// version: 1.0.3.0
// last update: 2005.01.05
// added primitive string function: upper/lower & compare
//
// ====================================================================
//  Copyright (c) 2004, D.Sofyan, Adrian Hafizh & Inge DR.
//  Property of PT SOFTINDO Jakarta.
//  All rights reserved.
// ====================================================================
//
//  (this format should stop spammer-bot, to be stripped are:
//   at@, brackets[], comma,, overdots., and dash-
//   do not strip underscore_)
//
//  mail,to:@[zero_inge]AT@-y.a,h.o.o.@DOTcom,
//  mail,to:@[aa]AT@-s.o.f.t,i.n.d.o.@DOTnet
//  http://delphi.softindo.net
//
//

// CHANGES
// 1.0.3.0
// fixed bug on _cCompare & _pcCompare

// note: don't ever let anything critical called under the
// try..except/finally construct (yes its very hard to be done),
// for that would degrade the performance down, the compiler
// inserts e-trap everywhere, in every function calls' frame you will
// find the fs: along with her families and brotherhoods, pushing-
// poping and messes up every registers she met.
// its a kind of compilation plague virus. we think.

interface

function {TxSearch} CharPos(const Ch: Char; const S: string;
  const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
  const BackPos: boolean = FALSE): integer; register overload

function {TxSearch} CharPos(const Ch: Char; const S: string;
  const StartPos: integer; const IgnoreCase: boolean = FALSE;
  const BackPos: boolean = FALSE): integer; register overload

function {TxSearch} CharCount(const Ch: Char; const S: string;
  const StartPos: integer; const IgnoreCase: boolean = FALSE;
  const BackPos: boolean = FALSE): integer; register overload

function {TxSearch} CharCount(const Ch: Char; const S: string;
  const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
  const BackPos: boolean = FALSE): integer; register overload

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// sometimes it is more useful to find a pair of chars
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// here WChar means a pair of Chars (double-chars)

function {TxSearch} WCharPos(const firstChar, secondChar: Char;
  const S: string; const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload

function {TxSearch} WCharPos(const firstChar, secondChar: Char;
  const S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload

function {TxSearch} WCharPos(const CharsPair, S: string;
  const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload

function {TxSearch} WCharPos(const CharsPair, S: string;
  const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload

function {TxSearch} WCharCount(const firstChar, secondChar: Char;
  const S: string; const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload

function {TxSearch} WCharCount(const firstChar, secondChar: Char;
  const S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload

function {TxSearch} WCharCount(const CharsPair, S: string;
  const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload

function {TxSearch} WCharCount(const CharsPair, S: string;
  const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload


function UpperStr(const S: string): string;
function LowerStr(const S: string): string;
procedure UpperBuff(var Buffer; const Length: integer);
procedure LowerBuff(var Buffer; const Length: integer);

function SameText(const S1, S2: string; const IgnoreCase: boolean = TRUE): boolean;
function SameBuffer(const P1, P2; const L1, L2: integer; const IgnoreCase: boolean = TRUE): boolean; forward;
procedure xMove(const Src; var Dest; Count: integer); register assembler; forward

// used only for monotoned/repeated chars as 'cccc','xxxxxx'
// function _RepPos(const Ch: Char; const S: string; const StartPos: integer;
//  const RepCount: integer; const IgnoreCase: boolean): integer;
function RepPos(const Ch: Char; const S: string; const RepCount: integer;
  const StartPos: integer = 1; const IgnoreCase: boolean = FALSE): integer;

function PRepPos(const Ch: Char; const P: PChar; const StartPos: cardinal;
  const PLength: cardinal; const RepCount: integer;
  const IgnoreCase: boolean): integer; register overload
function _RepPos(const Ch: Char; const S: string; const StartPos: integer;
  const RepCount: integer; const IgnoreCase: boolean): integer;

// implementation samples
// returns position of N-th occurrence of specified char (same rule also for WordNth below)
function CharNth(const Index: integer; const Ch: Char; const S: string;
  const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
  const BackPos: boolean = FALSE): integer; register overload
// Index is 1-based, 0 means error (either S is blank or StartPos is out-of-range)
// function CharAtIndex(const Index: integer; const Ch: Char; const S: string;
//   const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
//   const BackPos: boolean = FALSE): integer; register overload

function WordNth(const Index: integer; const S: string; const delimiter: Char; //= ' ';
  const StartPos: integer = 1; const IgnoreCase: boolean = FALSE; const BackPos: boolean = FALSE): string;
// Index is 1-based, 0 means error (either S is blank or StartPos is out-of-range)
// function WordAtIndex(const Index: integer; const S: string; const delimiter: Char = ' ';
//   const StartPos: integer = 1; const backpos: boolean = FALSE; const IgnoreCase: boolean = FALSE): string;

function WordCount(const S: string; const delimiter: Char {= ' '}; const StartPos: integer = 1;
  const BackPos: boolean = FALSE; const IgnoreCase: boolean = FALSE): integer;
// actually it is not quite a word count, but count of substring with delimited by one
// particular char, used for array or list of known formatted string with specific delimiter
// such as CSV (comma separated Values) or tab/space separated values etc.
// no harm for other (non formatted, arbitrary text), just doesn't make sense
// maybe ignoreCase better be turned off since delimiter should be case-sensitive anyway
// (deprecated, now its simply equal with CharCount +1, except for an empty string which
// returns 0, we dont know whether this is appropriate, since an empty string still is
// containing a string, despite it is blank)
// Default Delimiter commented since it very easy to overlooked
// note: IgnoreCase applies to Delimiter NOT to word to be searched for

function WordIndexOf(const SubStr, S: string; const Delimiter: char;
  const LengthToBeCompared: integer = MaxInt; const ignoreCaseSubStr: boolean = TRUE;
  const StartPos: integer = 1; const BackPos: boolean = FALSE;
  const ignoreCaseDelimiter: boolean = FALSE): integer;
// note: IgnoreCaseSubStr applies to SubStr to be searched for
//       IgnoreCaseDelimiter applies to Delimiter

//function PosCRLF(const S: string; const StartPos: integer = 1): integer;
//function UNIXed(const CRLFText: string): string;
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// test...
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

type
  TCharSetTable = array[char] of integer;
// pack words (replace all non-words-characters by single char/delimiter)
// TCharSetTable specifies the word/non-word character by zeroing at their ordinal position
// such as: elemen[SPACE] := 0 ~> if SPACE is not counted as a word's character
// another initialization example:
// var
//   Ch:Char;
//   CharTable:TCharSetTable;
// const
//   ALPHANUMERIC = ['0'..'9', 'A'..'Z', 'a'..'z'];
// ...
//   fillchar(CharsTable, sizeOf(CharsTable), 0);
//   for Ch := Low(Ch) to high(Ch) do
//     if Ch in ALPHANUMERIC then
//       CharsTable[Ch] := 1;
// ...

function PackWords(const table: TCharSetTable; const S: string; const delimiter: char): string;
function PackWordsUppercase(const table: TCharSetTable; const S: string; const delimiter: char): string;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// miscellaneous
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function ControlCharPos(const S: string; const StartPos: integer = 1): integer;
function HiBitCharPos(const S: string; const StartPos: integer = 1): integer;
function HiBitCharCount(const S: string; const StartPos: integer = 1): integer;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Low level-routines. NOT overloaded anymore to avoid ambiguities
//  Naming convention:
//  a. Source
//     _ : string version
//     p : pChar version
//  b. Direction
//     (none) : normal/forward
//     b : backpos
//  c. Case option
//     c : case-sensitive
//     i : ignorecase (non-sensitive)
//
///finalized
function pcCharPos(const Ch: Char; const P: PChar; const StartPos,
  PLength: cardinal): integer register assembler; //overload forward
function piCharPos(const Ch: Char; const P: PChar; const StartPos,
  PLength: cardinal): integer register assembler; //overload forward
function pcWCharPos(const Word: Word; const P: PChar; const StartPos,
  PLength: cardinal): integer register assembler; //overload forward
function piWCharPos(const Word: Word; const P: PChar; const StartPos,
  PLength: cardinal): integer register assembler; //overload forward

{.$DEFINE DEBUG}// to make them globally accessible
{$IFDEF DEBUG}
function _cCharPos(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward
function _iCharPos(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward

function pbcCharPos(const Ch: Char; const P: PChar;
  const StartPos, PLength: cardinal): integer register assembler; //overload forward
function pbiCharPos(const Ch: Char; const P: PChar;
  const StartPos, PLength: cardinal): integer register assembler; //overload forward
function _bcCharPos(const Ch: Char; const S: string;
  const StartPos: integer = {0} 1): integer register assembler; //overload forward
function _biCharPos(const Ch: Char; const S: string;
  const StartPos: integer = 0): integer register assembler; //overload forward

function pcCharCount(const Ch: Char; const P: PChar;
  const StartPos, PLength: cardinal): integer register assembler; //overload forward
function piCharCount(const Ch: Char; const P: PChar;
  const StartPos, PLength: cardinal): integer register assembler; //overload forward
function _cCharCount(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward
function _iCharCount(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward

function _cCompare(const S1, S2: string): integer; //forward;
function _iCompare(const S1, S2: string): integer; //forward;

function pcCompare(const P1, P2; const L1, L2: integer): integer; //forward;
function piCompare(const P1, P2; const L1, L2: integer): integer; //forward;
///

// tryout: experimental-stage3 status:OK
// returns position of N-th occurrence of char
function _cCharIndexPos(const Ch: Char; const S: string;
  const StartPos: integer { = 1}; const Index: integer): integer;
function _iCharIndexPos(const Ch: Char; const S: string;
  const StartPos: integer { = 1}; const Index: integer): integer;

// tryout: experimental-stage2 status:OK
function _bcCharIndexPos(const Ch: Char; const S: string;
  const StartPos: integer { = 1}; const Index: integer): integer;
function _biCharIndexPos(const Ch: Char; const S: string;
  const StartPos: integer { = 1}; const Index: integer): integer;

// tryout: experimental-stage2 status:OK
function _bcCharCount(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward
function _biCharCount(const Ch: Char; const S: string;
  const StartPos: integer = 1): integer register assembler; //overload forward

function _cWordPos(const Word: Word; const S: ANSIString;
  const StartPos: integer = 1): integer;
function _cWordCount(const Word: Word; const S: ANSIString;
  const StartPos: integer = 1): integer;
function _icWordPos(const Word: Word; const S: ANSIString;
  const StartPos: integer = 1): integer;
function _icWordCount(const Word: Word; const S: ANSIString;
  const StartPos: integer = 1): integer;

{$ENDIF DEBUG}
implementation
uses cxGlobal;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  ChPos ~ String version
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function _cCharPos(const Ch: Char; const S: string;
const StartPos: integer = 1): integer; assembler asm
  //~@@Start: push esi
  //~  test S, S; jz @@zero // check S length
  //~  mov esi, S.SzLen
  //~  cmp StartPos, esi; jle @@begin
  //~@@zero: xor eax, eax; jmp @@Stop
  //~@@begin: push S
  //~  sub StartPos, esi; add S, esi
  //~@_Loop:
  //~  cmp al, byte ptr S[StartPos-1]; je @@found
  //~  inc StartPos; jle @_Loop
  //~  xor eax,eax; jmp @@end
  //~@@found: sub S, [esp]; lea eax, S + StartPos
  //~@@end: pop S
  //~@@Stop: pop esi

  // using simpler base-index should be faster
  // or at least pairing enabled
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jg @@notfound
  @_Loop:
    cmp al, [esi]; lea esi, esi +1; je @@found
    inc StartPos; jle @_Loop
  @@notfound: mov esi, S
  @@found: sub esi, S; mov eax, esi
  @@end: pop esi
  @@Stop:
end;

function _iCharPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
  @@Start: push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jle @@zero // still need to be checked
    mov ebx, S.szLen
    cmp StartPos, ebx; jle @@Open
  @@zero: xor eax, eax; jmp @@Stop
  @@Open: //movzx eax, &Ch
    mov al, &Ch
    and eax, MAXBYTE
    push edi
    lea edi, locasetable
  @@begin: push esi; push S
    sub StartPos, ebx; add S, ebx
    lea esi, S + StartPos -1
    mov al, edi[eax]
    cmp al, byte ptr UPCASETABLE[eax]; je @_LoopNC
    mov bl, al
  @_Loop:
    //mov al, byte ptr S[StartPos-1];
    mov al, [esi]; lea esi, esi +1
    cmp bl, edi[eax]; je @@found
    inc StartPos; jle @_Loop
    jmp @@notfound
  @_LoopNC:
    //cmp al, byte ptr S[StartPos-1]; je @@found
    cmp al, [esi]; lea esi, esi +1; je @@found
    inc StartPos; jle @_LoopNC
  @@notfound: xor eax,eax; jmp @@end
  @@found: sub S, [esp]; lea eax, S + StartPos
  @@end: pop S; pop esi
  @@Close: pop edi
  @@Stop: pop ebx
end;

//BackPos

function _bcCharPos(const Ch: Char; const S: string;
const StartPos: integer = {0} 1): integer; assembler asm
  //~@@Start: push esi
  //~  test S, S; jz @@zero // check S length
  //~  mov esi, S.SzLen
  //~  cmp StartPos, esi; jle @@begin
  //~@@zero: xor eax, eax; jmp @@Stop
  //~@@begin: //push S
  //~  {sub StartPos, esi; add S, esi}
  //~@_Loop:
  //~  cmp al, byte ptr S[StartPos-1]; je @@found
  //~  dec StartPos; jnz @_Loop
  //~  xor eax,eax; jmp @@end
  //~@@found: mov eax, StartPos//sub S, [esp]; lea eax, S + StartPos
  //~@@end: //pop S
  //~@@Stop: pop esi

  // using simpler base-index should be faster
  // or at least pairing enabled
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    //sub StartPos, S.SzLen; jg @@notfound
    cmp StartPos, S.SzLen; jg @@notfound
  @_Loop:
    cmp al, [esi]; je @@found
    lea esi, esi -1; dec StartPos; jg @_Loop
  @@notfound: mov StartPos, 0//lea esi, S -1
  @@found: mov eax, StartPos//sub esi, S; lea eax, esi +1
  @@end: pop esi
  @@Stop:
end;

function _biCharPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
  @@Start: push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jle @@zero
    mov ebx, S.szLen
    cmp StartPos, ebx; jle @@Open
  @@zero: xor eax, eax; jmp @@Stop
  @@Open: //movzx eax, &Ch
    mov al, &Ch
    and eax, MAXBYTE
    push edi
    lea edi, locasetable
  @@begin: push esi//; push S
    {sub StartPos, ebx; add S, ebx}
    lea esi, S + StartPos -1
    mov al, edi[eax]
    cmp al, byte ptr UPCASETABLE[eax]; je @_LoopNC
    mov bl, al
  @_Loop:
    //mov al, byte ptr S[StartPos-1];
    mov al, [esi]; cmp bl, edi[eax]; je @@found
    lea esi, esi -1; dec StartPos; jg @_Loop
    jmp @@notfound
  @_LoopNC:
    //cmp al, byte ptr S[StartPos-1]; je @@found
    cmp al, [esi]; je @@found;
    lea esi, esi -1; dec StartPos; jg @_LoopNC
  @@notfound: xor eax,eax; jmp @@end
  @@found: mov eax, StartPos//sub S, [esp]; lea eax, S + StartPos
  @@end: {pop S; }pop esi
  @@Close: pop edi
  @@Stop: pop ebx
end;

function _cCharCount(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin // still need to be checked
  @@zero:
    xor eax, eax; jmp @@EXIT
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; mov S, 0; jg @@done
    @_Loop:
      cmp al, [esi]; lea esi, esi +1; jne @_
      ; inc S
    @_: inc StartPos; jle @_Loop
  @@done: mov eax, S
  @@end: pop esi
  @@EXIT:
end;

function _iCharCount(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin // still need to be checked
  @@zero:
    xor eax, eax; jmp @@EXIT
  @@begin: push esi; push edi; push ebx
    and eax, MAXBYTE
    lea edi, locasetable
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; mov S, 0; jg @@done
    mov bl, edi + eax
    cmp bl, byte ptr UPCASETABLE[eax]; je @_LoopNC
    @_Loop:
      mov al, [esi]; lea esi, esi +1
      cmp bl, edi + eax
      jne @_; inc S
    @_:inc StartPos; jle @_Loop; jmp @@done
    @_LoopNC:
      cmp al, [esi]; lea esi, esi +1; jne @e
      ; inc S
    @e: inc StartPos; jle @_LoopNC
    @@done: mov eax, S
  @@end: pop ebx; pop edi; pop esi
  @@EXIT:
end;

function _bcCharCount(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@Start
  @@zero:  xor eax, eax; jmp @@EXIT
  @@Start: push esi
    lea esi, S + StartPos -1
    //sub StartPos, S.SzLen; mov S,0; jg @@found
    cmp StartPos, S.SzLen; mov S, 0; jg @@done
    @_Loop:
      cmp al, [esi]; lea esi, esi -1; jne @_
      ; inc S
    @_: dec StartPos; jg @_Loop
  @@done: mov eax, S
  @@Stop: pop esi
  @@EXIT:
end;

function _biCharCount(const Ch: Char; const S: string;
const StartPos: integer { = 1}): integer; assembler asm
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin // still need to be checked
  @@zero:
    xor eax, eax; jmp @@EXIT
  @@begin: push esi; push edi; push ebx
    and eax, MAXBYTE
    lea edi, locasetable
    lea esi, S + StartPos -1
    //sub StartPos, S.SzLen; mov S, 0; jg @_found
    cmp StartPos, S.SzLen; mov S, 0; jg @@done
    mov bl, edi + eax
    cmp bl, byte ptr UPCASETABLE[eax]; je @_LoopNC
    @_Loop:
      mov al, [esi]; lea esi, esi -1
      cmp bl, edi + eax; jne @_
      ; inc S
    @_:dec StartPos; jg @_Loop; jmp @@done
    @_LoopNC:
      cmp al, [esi]; lea esi, esi -1; jne @e
      ; inc S
    @e: dec StartPos; jg @_LoopNC
    @@done: mov eax, S
  @@end: pop ebx; pop edi; pop esi
  @@EXIT:
end;

function _cCharIndexPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}; const Index: integer): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi; push S
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jg @@notfound
    mov S, Index; dec S; jl @@notfound
  @_Loop:
    cmp al, [esi]; lea esi, esi +1; jne @_//je @@found
    dec S; jl @@found
  @_:inc StartPos; jle @_Loop
  @@notfound: mov esi, [esp]
  @@found: sub esi, [esp]; mov eax, esi
  @@end: pop S; pop esi
  @@Stop:
end;

function _iCharIndexPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}; const Index: integer): integer; assembler asm
  @@Start: //push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jle @@zero // still need to be checked
  @@warning_esi_pushed: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.szLen; jle @@begin
  @@Warning_esi_poped: pop esi // orphaned pop
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: //movzx eax, &Ch
    {push esi;} push edi; push S
    lea edi, locasetable
    mov al, &Ch
    and eax, MAXBYTE
    mov S, Index; dec S; jl @@notfound

    mov al, edi[eax]
    cmp al, byte ptr UPCASETABLE[eax]; je @_LoopNC
    mov bl, al
  @_Loop:
    //mov al, byte ptr S[StartPos-1];
    mov al, [esi]; lea esi, esi +1
    cmp bl, edi[eax]; jne @_//je @@found
    dec S; jl @@found
  @_:inc StartPos; jle @_Loop; jmp @@notfound
  @_LoopNC:
    //cmp al, byte ptr S[StartPos-1]; je @@found
    cmp al, [esi]; lea esi, esi +1; jne @e//je @@found
    dec S; jl @@found
  @e:inc StartPos; jle @_LoopNC
  @@notfound: mov [esp], esi
  @@found: sub esi, [esp]; mov eax, esi
  @@end: pop S; pop edi; pop esi
  @@Stop: //pop ebx
end;

function _bcCharIndexPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}; const Index: integer): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi; push S
    lea esi, S + StartPos -1
    //sub StartPos, S.SzLen; jg @@notfound
    cmp StartPos, S.SzLen; jg @@notfound
    mov S, Index; dec S; jl @@notfound
  @_Loop:
    cmp al, [esi]; jne @_//je @@found
    dec S; jl @@found
  @_:dec StartPos; lea esi, esi -1; jg @_Loop
  @@notfound: mov esi, [esp]; dec esi
  @@found: sub esi, [esp]; lea eax, esi +1
  @@end: pop S; pop esi
  @@Stop:
end;

function _biCharIndexPos(const Ch: Char; const S: string;
const StartPos: integer { = 1}; const Index: integer): integer; assembler asm
  @@Start: //push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jle @@zero // still need to be checked
  @@warning_esi_pushed: push esi
    lea esi, S + StartPos -1
    //sub StartPos, S.szLen; jle @@begin
    cmp StartPos, S.szLen; jle @@begin
  @@Warning_esi_poped: pop esi // orphaned pop
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: //movzx eax, &Ch
    {push esi;} push edi; push S
    lea edi, locasetable
    mov al, &Ch
    and eax, MAXBYTE
    mov S, Index; dec S; jl @@notfound

    mov al, edi[eax]
    cmp al, byte ptr UPCASETABLE[eax]; je @_LoopNC
    mov bl, al
  @_Loop:
    //mov al, byte ptr S[StartPos-1];
    mov al, [esi]; cmp bl, edi[eax]; jne @_//je @@found
    dec S; jl @@found;
    @_:dec StartPos; ; lea esi, esi -1;jg @_Loop; jmp @@notfound
  @_LoopNC:
    //cmp al, byte ptr S[StartPos-1]; je @@found
    cmp al, [esi]; jne @e//je @@found
    dec S; jl @@found
    @e:dec StartPos; lea esi, esi -1; jg @_LoopNC
  @@notfound: mov esi, [esp]; dec esi
  @@found: sub esi, [esp]; lea eax, esi +1
  @@end: pop S; pop edi; pop esi
  @@Stop: //pop ebx
end;

function _RepPos(const Ch: Char; const S: string; const StartPos: integer;
const RepCount: integer; const IgnoreCase: boolean): integer; assembler asm
  @@Start: push esi
    or S, S; je @@zero
    test StartPos, StartPos; jle @@zero
    cmp StartPos, S.szLen; jle @begin
  @@zero: xor eax, eax; jmp @@Stop
  @begin: push esi; push edi; push ebx
    mov esi, S
    push esi            // save original address
    mov al, &Ch
    and eax, MAXBYTE
    mov edi, esi
    lea esi, esi + StartPos -1
    add edi, edi.szLen
    mov ecx, RepCount
    dec ecx
    mov edx, ecx; sub edi, ecx
    test IgnoreCase, 1; jnz @@CaseInsensitive

    @@CaseSensitive:
    @_Repeat:
      cmp esi, edi; jg @@notfound  // note!
      cmp al, esi[edx]; jne @_skip
    @_Loop:
      dec ecx; jl @@found
      cmp al, esi[ecx]; je @_Loop
    @_forward:
      lea esi, esi + ecx +1; mov ecx, edx
      jmp @_Repeat
    @_skip:
      lea esi, esi + edx +1; jmp @_Repeat

    @@CaseInsensitive:
      xor ebx, ebx
      mov bl, byte ptr locasetable[eax]
      cmp bl, byte ptr UPCASETABLE[eax]
      je @@CaseSensitive

    @_iRepeat:
      cmp esi, edi; jg @@notfound
      mov al, esi[edx]
      cmp bl, byte ptr locasetable[eax]; jne @_iSkip
    @_iLoop:
      dec ecx; jl @@found
      mov al, esi[ecx]
      cmp bl, byte ptr locasetable[eax]; je @_iLoop
    @_iForward:
      lea esi, esi + ecx +1; mov ecx, edx
      jmp @_iRepeat
    @_iSkip:
      lea esi, esi + edx +1; jmp @_iRepeat

  @@notfound: lea eax, esi +1; mov [esp], eax
  @@found: pop edi; sub esi, edi; lea eax, esi +1
  @@end: pop ebx; pop edi; pop esi
  @@Stop: pop esi
end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// implementation
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function {txSearch} CharPos(const Ch: Char; const S: string;
  const StartPos: integer; const IgnoreCase: boolean = FALSE;
  const BackPos: boolean = FALSE): integer;
begin
  if not BackPos then
    if IgnoreCase then
      Result := _iCharPos(Ch, S, StartPos)
    else
      Result := _cCharPos(Ch, S, StartPos)
  else if IgnoreCase then
    Result := _biCharPos(Ch, S, StartPos)
  else
    Result := _bcCharPos(Ch, S, StartPos)
end;

function {txSearch} CharPos(const Ch: Char; const S: string;
  const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
  const BackPos: boolean = FALSE): integer;
begin
  Result := CharPos(Ch, S, StartPos, IgnoreCase, BackPos)
end;

function {txSearch} RepPos(const Ch: Char; const S: string; const RepCount: integer;
  const StartPos: integer = 1; const IgnoreCase: boolean = FALSE): integer;
begin
  if RepCount < 2 then
    Result := CharPos(Ch, S, StartPos, IgnoreCase)
  else
    Result := _RepPos(Ch, S, StartPos, RepCount, IgnoreCase);
end;

function {txSearch} CharCount(const Ch: Char; const S: string;
  const StartPos: integer; const IgnoreCase: boolean = FALSE;
  const BackPos: boolean = FALSE): integer;
begin
  if BackPos then
    if IgnoreCase then
      Result := _biCharCount(Ch, S, StartPos)
    else
      Result := _bcCharCount(Ch, S, StartPos)
  else if IgnoreCase then
    Result := _iCharCount(Ch, S, StartPos)
  else
    Result := _cCharCount(Ch, S, StartPos)
end;

function {txSearch} CharCount(const Ch: Char; const S: string;
  const IgnoreCase: boolean = FALSE; const StartPos: integer = 1;
  const BackPos: boolean = FALSE): integer;
begin
  Result := CharCount(Ch, S, StartPos, IgnoreCase, BackPos)
end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  expos ~ PChar version
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function pcCharPos(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi
    and eax, MAXBYTE
    lea esi, P + StartPos -1
    sub StartPos, PLength; ja @_notfound
    @_Loop:
      cmp al, [esi]; lea esi, esi +1; je @@found
      inc StartPos; jle @_Loop
    @_notfound: xor eax, eax; jmp @@end
  @@found: mov eax, esi; sub eax, P
  @@end: pop esi
end;

function piCharPos(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi; push edi; push ebx
    and eax, MAXBYTE
    lea edi, locasetable
    lea esi, P + StartPos -1
    sub StartPos, PLength; ja @_notfound
    mov bl, edi + eax
    cmp bl, byte ptr UPCASETABLE[eax]; je @_LoopNC
    @_Loop:
      mov al, [esi]; lea esi, esi +1
      cmp bl, edi + eax; je @@found
      inc StartPos; jle @_Loop
      jmp @_notfound
    @_LoopNC:
      cmp al, [esi]; lea esi, esi +1; je @@found
      inc StartPos; jle @_LoopNC
    @_notfound: xor eax, eax; jmp @@end
  @@found: mov eax, esi; sub eax, P
  @@end: pop ebx; pop edi; pop esi
end;

function pbcCharPos(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi
    and eax, MAXBYTE
    lea esi, P + StartPos -1
    cmp StartPos, PLength; ja @_notfound
    @_Loop:
      cmp al, [esi]; lea esi, esi -1; je @@found
      sub StartPos, 1; jnb @_Loop
    @_notfound: xor eax, eax; jmp @@end
  @@found: lea eax, StartPos +1//mov eax, esi; sub eax, P
  @@end: pop esi
end;

function pbiCharPos(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi; push edi; push ebx
    and eax, MAXBYTE
    lea edi, locasetable
    lea esi, P + StartPos -1
    cmp StartPos, PLength; ja @_notfound
    mov bl, edi + eax
    cmp bl, byte ptr UPCASETABLE[eax]; je @_LoopNC
    @_Loop:
      mov al, [esi]; lea esi, esi +1
      cmp bl, edi + eax; je @@found
      sub StartPos, 1; jnb @_Loop
      jmp @_notfound
    @_LoopNC:
      cmp al, [esi]; lea esi, esi -1; je @@found
      sub StartPos, 1; jnb @_LoopNC
    @_notfound: xor eax, eax; jmp @@end
  @@found: lea eax, StartPos +1//mov eax, esi; sub eax, P
  @@end: pop ebx; pop edi; pop esi
end;

function pcCharCount(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi
    lea esi, P + StartPos -1
    xor P, P
    sub StartPos, PLength; jg @@found
    @_Loop:
      cmp al, [esi]; lea esi, esi +1; jne @_
      ; lea P, P+1
    @_: inc StartPos; jle @_Loop
  @@found: mov eax, P
  @@end: pop esi
end;

function piCharCount(const Ch: Char; const P: PChar;
const StartPos, PLength: cardinal): integer; assembler asm
  @@begin: push esi; push edi; push ebx
    and eax, MAXBYTE
    lea edi, locasetable
    lea esi, P + StartPos -1
    xor P, P
    sub StartPos, PLength; jg @_found
    mov bl, edi + eax
    cmp bl, byte ptr UPCASETABLE[eax]; je @_LoopNC
    @_Loop:
      mov al, [esi]; lea esi, esi +1
      cmp bl, edi + eax; jne @_
      ; lea P, P +1
      @_:inc StartPos; jle @_Loop; jmp @_found
    @_LoopNC:
      cmp al, [esi]; lea esi, esi +1
      jne @e; lea P, P+1
      @e: inc StartPos; jle @_LoopNC
    @_found: mov eax, P
  @@end: pop ebx; pop edi; pop esi
end;

function PRepPos(const Ch: Char; const P: PChar; const StartPos: cardinal;
  const PLength: cardinal; const RepCount: integer;
const IgnoreCase: boolean): integer; register overload assembler asm
  @@Start:
    or P, P; je @@zero
    test StartPos, StartPos; jle @@zero  // StartPos = 0?
    cmp StartPos, PLength; jle @begin    // StartPos >= Length(S) ?

  @@zero: xor eax, eax; jmp @@Stop
  @begin: push esi; push edi; push ebx
    mov esi, P
    push esi            // save original address
    mov al, &Ch
    and eax, MAXBYTE
    mov edi, esi
    lea esi, esi + StartPos -1
    add edi, PLength
    mov ecx, RepCount
    dec ecx
    mov edx, ecx; sub edi, ecx
    test IgnoreCase, 1; jnz @@CaseInsensitive

    @@CaseSensitive:
    @_Repeat:
      cmp esi, edi; jg @@notfound  // note!
      cmp al, esi[edx]; jne @_skip
    @_Loop:
      dec ecx; jl @@found
      cmp al, esi[ecx]; je @_Loop
    @_forward:
      lea esi, esi + ecx +1; mov ecx, edx
      jmp @_Repeat
    @_skip:
      lea esi, esi + edx +1; jmp @_Repeat

    @@CaseInsensitive:
      xor ebx, ebx
      mov bl, byte ptr locasetable[eax]
      cmp bl, byte ptr UPCASETABLE[eax]
      je @@CaseSensitive

    @_iRepeat:
      cmp esi, edi; jg @@notfound
      mov al, esi[edx]
      cmp bl, byte ptr locasetable[eax]; jne @_iSkip
    @_iLoop:
      dec ecx; jl @@found
      mov al, esi[ecx]
      cmp bl, byte ptr locasetable[eax]; je @_iLoop
    @_iForward:
      lea esi, esi + ecx +1; mov ecx, edx
      jmp @_iRepeat
    @_iSkip:
      lea esi, esi + edx +1; jmp @_iRepeat

  @@notfound: lea eax, esi +1; mov [esp], eax
  @@found: pop edi; sub esi, edi; lea eax, esi +1
  @@end: pop ebx; pop edi; pop esi
  @@Stop:
end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Chars Pair / Double Chars routines
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function _cWordPos_old(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jge @@notfound
  @_Loop: // better play safe here
    cmp al, [esi]; lea esi, esi +1; je @@found1
    inc StartPos; jl @_Loop; jmp @@notfound
  @@found1:
    cmp ah, [esi]; je @@found; lea esi, esi +1
    add StartPos, 2; jl @_Loop
  @@notfound: mov esi, S
  @@found: sub esi, S; mov eax, esi
  @@end: pop esi
  @@Stop:
end;

function _cWordCount_old(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; mov S, 0; jge @@done
  @_Loop: // better play safe here
    cmp al, [esi]; lea esi, esi +1; je @@found1
    inc StartPos; jl @_Loop; jmp @@done
  @@found1:
    cmp ah, [esi]; lea esi, esi +1; jne @@_
    ; inc S
    @@_:add StartPos, 2; jl @_Loop
  @@done: mov eax, S
  @@end: pop esi
  @@Stop:
end;

function _cWordPos(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jge @@notfound
  @_Loop: // better play safe here
    cmp al, [esi]; lea esi, esi +1; je @@found1
    inc StartPos; jl @_Loop; jmp @@notfound
  @@found1:
    cmp ah, [esi]; lea esi, esi +1; je @@found
    add StartPos, 2; jl @_Loop
  @@notfound: mov esi, S; inc esi
  @@found: sub esi, S; lea eax, esi -1
  @@end: pop esi
  @@Stop:
end;

function _cWordCount(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; mov S, 0; jge @@done
  @_Loop: // better play safe here
    cmp al, [esi]; lea esi, esi +1; je @@found1
    inc StartPos; jl @_Loop; jmp @@done
  @@found1:
    cmp ah, [esi]; lea esi, esi +1; jne @@_
    ; inc S
    @@_:add StartPos, 2; jl @_Loop
  @@done: mov eax, S
  @@end: pop esi
  @@Stop:
end;

function _icWordPos(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start: push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push edi; push esi
  lea esi, S + StartPos -1
  sub StartPos, S.SzLen; jge @@notfound
    lea edi, locasetable
    xor ebx, ebx
    mov bl, ah
    mov bh, edi[ebx]
    and eax, MAXBYTE
    mov bl, edi[eax]
  @@test1:
    cmp bl, eax[UPCASETABLE]; jne @@_LoopCC
  @@test2:
    mov al, bh
    cmp bh, eax[UPCASETABLE]; jne @@_LoopCC
    mov eax, ebx
  @@_LoopNC:
    cmp al, [esi]; lea esi, esi +1; je @@foundNC
    inc StartPos; jl @@_LoopNC; jmp @@notfound
  @@foundNC:
    cmp ah, [esi]; lea esi, esi +1; je @@found;
    add StartPos, 2; jl @@_LoopNC; jmp @@notfound
  @@_LoopCC: // better play safe here
    mov al, [esi]; lea esi, esi +1
    cmp bl, edi[eax]; je @@foundCC;
    inc StartPos; jl @@_LoopCC; jmp @@notfound
  @@foundCC:
    mov al, [esi]; lea esi, esi +1
    cmp bh, edi[eax]; je @@found;
    add StartPos, 2; jl @@_LoopCC
  @@notfound: mov esi, S; inc esi
  @@found: sub esi, S; lea eax, esi-1
  @@end: pop esi; pop edi
  @@Stop: pop ebx
end;

function _icWordCount(const Word: Word; const S: ANSIString;
const StartPos: integer = 1): integer; assembler asm
  @@Start: push ebx
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push edi; push esi
  lea esi, S + StartPos -1
  sub StartPos, S.SzLen; mov S, 0; jge @@done
    lea edi, locasetable
    xor ebx, ebx
    mov bl, ah
    mov bh, edi[ebx]
    and eax, MAXBYTE
    mov bl, edi[eax]
  @@test1:
    cmp bl, eax[UPCASETABLE]; jne @@_LoopCC
  @@test2:
    mov al, bh
    cmp bh, eax[UPCASETABLE]; jne @@_LoopCC
    mov eax, ebx
  @@_LoopNC:
    cmp al, [esi]; lea esi, esi +1; je @@foundNC
    inc StartPos; jl @@_LoopNC; jmp @@done
  @@foundNC:
    cmp ah, [esi]; lea esi, esi +1; jne @@_NC; inc S
  @@_NC:add StartPos, 2; jl @@_LoopNC; jmp @@done
  @@_LoopCC:
    mov al, [esi]; lea esi, esi +1
    cmp bl, edi[eax]; je @@foundCC
    inc StartPos; jl @@_LoopCC; jmp @@done
  @@foundCC:
    mov al, [esi]; lea esi, esi +1
    cmp bh, edi[eax]; jne @@_CC; inc S
    @@_CC:add StartPos, 2; jl @@_LoopCC
  //@@notfound: mov esi, S
  //@@found: sub esi, S; mov eax, esi
  @@done: mov eax, S
  @@end: pop esi; pop edi
  @@Stop: pop ebx
end;

function pcWCharPos(const Word: Word; const P: PChar; const StartPos,
PLength: cardinal): integer register; assembler asm //overload forward
  //@@Start:
  //  test S, S; jz @@zero // check S length
  //  or StartPos, StartPos; jg @@begin //still need to be checked
  //@@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    and eax, MAXWORD
    lea esi, P + StartPos -1
    sub StartPos, PLength; jge @@notfound
  @_Loop: // better play safe here
    cmp al, [esi]; lea esi, esi +1; je @@found1
    inc StartPos; jl @_Loop; jmp @@notfound
  @@found1:
    cmp ah, [esi]; lea esi, esi +1; je @@found
    add StartPos, 2; jl @_Loop
  @@notfound: xor eax, eax; jmp @@end//mov esi, S; inc esi
  @@found: sub esi, P; lea eax, esi -1
  @@end: pop esi
  @@Stop:
end;

function piWCharPos(const Word: Word; const P: PChar; const StartPos,
PLength: cardinal): integer register; assembler asm //overload forward
  @@begin: push ebx; push edi; push esi
  lea esi, P + StartPos -1
  sub StartPos, PLength; jge @@notfound
    lea edi, locasetable
    xor ebx, ebx
    mov bl, ah
    mov bh, edi[ebx]
    and eax, MAXBYTE
    mov bl, edi[eax]
  @@test1:
    cmp bl, eax[UPCASETABLE]; jne @@_LoopCC
  @@test2:
    mov al, bh
    cmp bh, eax[UPCASETABLE]; jne @@_LoopCC
    mov eax, ebx
  @@_LoopNC:
    cmp al, [esi]; lea esi, esi +1; je @@foundNC
    inc StartPos; jl @@_LoopNC; jmp @@notfound
  @@foundNC:
    cmp ah, [esi]; lea esi, esi +1; je @@found;
    add StartPos, 2; jl @@_LoopNC; jmp @@notfound
  @@_LoopCC: // better play safe here
    mov al, [esi]; lea esi, esi +1
    cmp bl, edi[eax]; je @@foundCC;
    inc StartPos; jl @@_LoopCC; jmp @@notfound
  @@foundCC:
    mov al, [esi]; lea esi, esi +1
    cmp bh, edi[eax]; je @@found;
    add StartPos, 2; jl @@_LoopCC
  @@notfound: mov esi, P; inc esi
  @@found: sub esi, P; lea eax, esi-1
  @@end: pop esi; pop edi; pop ebx
end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  move, compare & conversion routines
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

procedure xMove(const Src; var Dest; Count: integer); assembler asm
// effective only for bulk transfer
// moving 4 bytes at the speed of 1,
// pairing enabled, no AGI-stalls
    push esi; push edi
    mov esi, Src; mov edi, Dest
    mov ecx, Count; mov eax, ecx
    sar ecx, 2; js @@end
    push eax; jz @@recall
  @@LoopDWord:
    mov eax, [esi]; lea esi, esi +4
    mov [edi], eax; lea edi, edi +4
    dec ecx; jg @@LoopDWord
  @@recall: pop ecx
    and ecx, 03h; jz @@LoopDone
  @@LoopByte:
    mov al, [esi]; lea esi, esi +1
    mov [edi], al; lea edi, edi +1
    dec ecx; jg @@LoopByte
  @@LoopDone:
  @@end:
    pop edi; pop esi
end;

function iCompare_old(const S1, S2: string): integer; assembler asm
  @@Start:
    push esi; push edi; push ebx
    mov esi, eax; mov edi, edx
    xor ebx, ebx
    or eax, eax; je @@zeroS1
    mov eax, eax.SzLen
  @@zeroS1:
    or edx, edx; je @@zeroS2
    mov edx, edx.SzLen
  @@zeroS2:
    mov ecx, eax
    cmp ecx, edx; jbe @@2
    mov ecx, edx
  @@2: dec ecx; jl @@done
  @@3:
    mov bl, [esi]; lea esi, esi +1
    cmp bl, [edi]; lea edi, edi +1
    je @@2
    mov bl, byte ptr LOCASETABLE[ebx]
    cmp bl, [edi -1]; je @@3
    xor eax, eax; mov al, [esi-1]
    xor edx, edx; mov dl, [edi-1]
  @@done:
    sub eax, edx
    pop ebx; pop edi; pop esi
  @@Stop:
end;

function _cCompare(const S1, S2: string): integer; assembler asm //
// efficient for long string
  @@Start:
    push esi; push edi; push ebx
    mov esi, S1; mov edi, S2

    test S1, S1; jz @_DoneAXLen; mov eax, S1.SzLen; @_DoneAXLen:
    test S2, S2; jz @_DoneDXLen; mov edx, S2.SzLen; @_DoneDXLen:

    mov ecx, eax; cmp ecx, edx; jbe @_prep
    mov ecx, edx

  @_prep: push ecx; shr ecx, 2; jz @_single

  @_Loop4: dec ecx; jl @_single
    mov ebx, [edi]; lea edi, edi +4
    cmp ebx, [esi]; lea esi, esi +4
    je @_Loop4

    //mov eax, [esi]; mov edx, ebx; jmp @_atremain //bug!
    mov eax, [esi-4]; mov edx, ebx; jmp @_atremain //fixed

  @_Loopremain: ror eax, 8; ror edx, 8
  @_atremain: cmp al, dl; je @_Loopremain
  @_remdone:
    and eax, $ff; and edx, $ff
    pop ecx; jmp @@done

  @_single: pop ecx; and ecx, 3; jz @@done

  @_Loop1: dec ecx; jl @@done
    mov bl, [esi]; lea esi, esi +1
    cmp bl, [edi]; lea edi, edi +1
    je @_Loop1

    xor eax, eax; mov al, bl
    //xor edx, edx; mov dl, [edi] //bug!
    xor edx, edx; mov dl, [edi-1] //fixed

  @@done:
    sub eax, edx
    pop ebx; pop edi; pop esi
  @@Stop:
end;

function _iCompare(const S1, S2: string): integer; assembler asm //
  //call System.@LStrCmp
  @@Start:
    push esi; push edi; push ebx
    mov esi, S1; mov edi, S2
    xor ebx, ebx; test S1, S1; je @_Zero1

    mov eax, S1.SzLen
  @_Zero1: test edx, edx; je @_Zero2
    mov edx, S2.SzLen
  @_Zero2: mov ecx, eax; cmp ecx, edx; jbe @@2

    mov ecx, edx
  @@2: dec ecx; jl @@done
  @Loop3:
    mov bl, [esi]; lea esi, esi +1
    mov bl, byte ptr locasetable[ebx]
    cmp bl, [edi]; lea edi, edi +1
    je @Loop3
    xor eax, eax; mov al, bl
    //xor edx, edx; mov dl, [edi] //bug!
    xor edx, edx; mov dl, [edi-1] //fixed
    @@done:
    sub eax, edx
    pop ebx; pop edi; pop esi
  @@Stop:
end;

function pcCompare(const P1, P2; const L1, L2: integer): integer; assembler asm //
// efficient for large buffer
  @@Start:
    push esi; push edi; push ebx
    mov esi, P1; mov edi, P2

    test P1, P1; je @_doneAX; mov eax, L1//eax.SzLen
  @_doneAX:
    test P2, P2; je @_doneDX; mov edx, L2//edx.SzLen
  @_doneDX:
    mov ecx, eax; cmp ecx, edx; jbe @_prep

    mov ecx, edx
  @_prep: push ecx; shr ecx, 2; jz @_single

  @_Loop4: dec ecx; jl @_single
    mov ebx, [edi]; lea edi, edi +4
    cmp ebx, [esi]; lea esi, esi +4
    je @_Loop4

    //mov eax, [esi]; mov edx, ebx; jmp @_atremain //bug!
    mov eax, [esi-4]; mov edx, ebx; jmp @_atremain //fixed

  @_Loopremain: ror eax, 8; ror edx, 8
  @_atremain: cmp al, dl; je @_Loopremain

    and eax, $ff; and edx, $ff
    pop ecx; jmp @@done

  @_single: pop ecx; and ecx, 3; jz @@done

  @_Loop1: dec ecx; jl @@done
    mov bl, [esi]; lea esi, esi +1
    cmp bl, [edi]; lea edi, edi +1
    je @_Loop1

    xor eax, eax; mov al, bl
    //xor edx, edx; mov dl, [edi] //bug!
    xor edx, edx; mov dl, [edi-1] //fixed

  @@done:
    sub eax, edx
    pop ebx; pop edi; pop esi
  @@Stop:
end;

function piCompare(const P1, P2; const L1, L2: integer): integer; assembler asm //
  @@Start:
    push esi; push edi; push ebx
    mov esi, P1; mov edi, P2
    xor ebx, ebx; test eax, eax; je @_Zero1
    mov eax, L1//eax.SzLen
  @_Zero1: test P2, P2; je @_Zero2
    mov edx, L2//edx.SzLen
  @_Zero2: mov ecx, eax; cmp ecx, edx; jbe @@2

    mov ecx, edx
  @@2: dec ecx; jl @@done
  @Loop3:
    mov bl, [esi]; lea esi, esi +1
    mov bl, byte ptr locasetable[ebx]
    cmp bl, [edi]; lea edi, edi +1
    je @Loop3
    xor eax, eax; mov al, bl
    //xor edx, edx; mov dl, [edi] //bug!
    xor edx, edx; mov dl, [edi-1] //fixed
  @@done:
    sub eax, edx
    pop ebx; pop edi; pop esi
  @@Stop:
end;

procedure CaseStr(var S: string; const CharsTable); assembler asm
  @@Start:
    mov S, [S] // S is a VAR! normalize.
    or S, S; jz @@Stop
    push esi; push edi
    push ecx
    mov esi, S
    mov edi, CharsTable
    mov ecx, esi.SzLen
    xor eax, eax
  @@Loop:
    dec ecx; jl @@end
    mov al, esi[ecx]
    cmp al, edi[eax]
    je @@Loop
    mov al, edi[eax]
    mov esi[ecx], al
    jmp @@Loop
  @@end:
    pop ecx
    pop edi; pop esi
  @@Stop:
end;

procedure TransBuffer(var Buffer; const Length: integer; const CharsTable); assembler asm
  @@Start:
    mov Buffer, [Buffer] // Buffer is a VAR! normalize.
    or Buffer, Buffer; jz @@Stop
    push esi; push edi
    push ecx
    mov esi, Buffer
    mov edi, CharsTable
    mov ecx, Length//esi.SzLen
    xor eax, eax
  @@Loop:
    dec ecx; jl @@end
    mov al, esi[ecx]
    cmp al, edi[eax]
    je @@Loop
    mov al, edi[eax]
    mov esi[ecx], al
    jmp @@Loop
  @@end:
    pop ecx
    pop edi; pop esi
  @@Stop:
end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// implementation & samples
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function UPPERSTR(const S: string): string;
begin
  Result := S;
  //SetLength(Result, length(S));
  UniqueString(Result);
  CaseStr(Result, UPCASETABLE);
end;

function lowerstr(const S: string): string;
begin
  Result := S;
  //SetLength(Result, length(S));
  UniqueString(Result);
  CaseStr(Result, locasetable);
end;

function SameText(const S1, S2: string; const IgnoreCase: boolean = TRUE): boolean;
begin
  if IgnoreCase then
    Result := _iCompare(S1, S2) = 0
  else
    Result := _cCompare(S1, S2) = 0
end;

function SameBuffer(const P1, P2; const L1, L2: integer;
  const IgnoreCase: boolean = TRUE): boolean;
begin
  if IgnoreCase then
    Result := piCompare(P1, P2, L1, L2) = 0
  else
    Result := pcCompare(P1, P2, L1, L2) = 0
end;

procedure UPPERBUFF(var Buffer; const Length: integer);
begin
  //Result := S;
  //SetLength(Result, length(S));
  //UniqueString(Result);
  TransBuffer(Buffer, Length, UPCASETABLE);
end;

procedure lowerbuff(var Buffer; const Length: integer);
begin
  //Result := S;
  //SetLength(Result, length(S));
  //UniqueString(Result);
  TransBuffer(Buffer, Length, locasetable);
end;

function CharNth(const Index: integer; const Ch: Char; const S: string; const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1; const BackPos: boolean = FALSE): integer; register overload
begin
  if BackPos then
    if IgnoreCase then
      Result := _biCharIndexPos(Ch, S, StartPos, Index)
    else
      Result := _bcCharIndexPos(Ch, S, StartPos, Index)
  else if IgnoreCase then
    Result := _iCharIndexPos(Ch, S, StartPos, Index)
  else
    Result := _cCharIndexPos(Ch, S, StartPos, Index)
end;

function WordNth(const Index: integer; const S: string; const delimiter: Char; //= ' ';
  const StartPos: integer = 1; const IgnoreCase: boolean = FALSE;
  const BackPos: boolean = FALSE): string;
// function WordAtIndex(const Index: integer; const S: string; const delimiter: Char = ' ';
// const StartPos: integer = 1; const BackPos: boolean = FALSE; const IgnoreCase: boolean = FALSE): string;
// no outrange/wordcount checking!!! wordnth(200000, 'abc', anychar) will result: 'abc'
// outrange check now fixed.
var
  n1, n2: integer;
begin
  if (Index < 1) then // simple outrange checks: or (Index > length(S)) then
    Result := ''
  else begin
    if not BackPos then begin
      if Index = 1 then begin
        n2 := CharNth(Index, delimiter, S, IgnoreCase, StartPos, BackPos);
        if n2 = 0 then
          n2 := length(S) + 1;
        Result := Copy(S, StartPos, n2 - StartPos);
      end
      else begin
        n1 := CharNth(Index - 1, delimiter, S, IgnoreCase, StartPos, BackPos);
        if n1 < 1 then
          Result := ''
        else begin
          inc(n1);
          n2 := CharNth(Index, delimiter, S, IgnoreCase, StartPos, BackPos);
          if n2 = 0 then
            n2 := length(S) + 1;
          Result := Copy(S, n1, n2 - n1);
        end;
      end;
    end
    else begin
      //backpos doesnot yet checked further for an outrange wordcount
      if index = 1 then
        n1 := StartPos + 1
      else
        n1 := CharNth(Index - 1, delimiter, S, IgnoreCase, StartPos, BackPos);
      n2 := CharNth(Index, delimiter, S, IgnoreCase, StartPos, BackPos) + 1;
      // //if n2 < 1 then n2 := length(S) + 1; //!
      Result := Copy(S, n2, n1 - n2);
    end;
  end
end;

// function WordCount_old(const S: string; const delimiter: Char = ' '; const StartPos: integer = 1; const BackPos: boolean = FALSE; const IgnoreCase: boolean = FALSE): integer;
// var
//   Len, n: integer;
// begin
//   Len := length(S);
//   if (StartPos < 1) or (StartPos > Len) then Result := 0
//   else begin
//   //if (StartPos > 0) and (Len >= StartPos) then begin
//     Result := CharCount(delimiter, S, StartPos, IgnoreCase, BackPos);
//     n := Len - StartPos + 1;
//     if S[StartPos] = delimiter then
//       dec(Result);
//     if BackPos then
//       if S[1] <> delimiter then
//         inc(Result)
//       else
//         if S[n] <> delimiter then
//           inc(Result)
//   end;
// end;

function WordCount(const S: string; const delimiter: Char {= ' '}; const StartPos: integer = 1;
  const BackPos: boolean = FALSE; const IgnoreCase: boolean = FALSE): integer;
begin
  if S = '' then
    Result := 0
  else
    Result := CharCount(delimiter, S, StartPos, IgnoreCase, BackPos) + 1;
end;

function WordIndexOf(const SubStr, S: string; const Delimiter: char;
  const LengthToBeCompared: integer = MaxInt; const ignoreCaseSubStr: boolean = TRUE;
  const StartPos: integer = 1; const BackPos: boolean = FALSE;
  const ignoreCaseDelimiter: boolean = FALSE): integer;

function min(const a, b: integer): integer; assembler asm
    cmp a, b; jle @end
    mov a, b;
    @end:
  end;

var
  i: integer;
  CS, CSubStr: string;
  M: integer;
begin
  Result := -1;
  if (S <> '') and (SubStr <> '') and (LengthToBeCompared > 0) then begin
    M := min(Length(SubStr), LengthToBeCompared);
    if (length(S) >= M) then begin
      CS := S;
      CSubStr := copy(SubStr, 1, M);
      if ignoreCaseSubStr then begin
        CS := UPPERSTR(CS);
        CSubStr := UPPERSTR(CSubStr);
      end;
      for i := 1 to WordCount(CS, Delimiter, StartPos, BackPos, IgnoreCaseDelimiter) do
        if copy(WordNth(i, CS, Delimiter, StartPos, ignoreCaseDelimiter, BackPos), 1, M) = CSubStr then begin
          Result := i;
          break;
        end;
    end;
  end;
end;


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// miscellaneous
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function {TxSearch} WCharPos(const firstChar, secondChar: Char;
  const S: string; const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload
var
  I: integer;
begin
  I := ord(secondChar) shl 8 or ord(firstChar);
  if IgnoreCase then
    Result := _icwordPos(I, S, StartPos)
  else
    Result := _cwordPos(I, S, StartPos)
end;

function {TxSearch} WCharPos(const firstChar, secondChar: Char;
  const S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload
var
  I: integer;
begin
  I := ord(secondChar) shl 8 or ord(firstChar);
  if IgnoreCase then
    Result := _icwordPos(I, S, StartPos)
  else
    Result := _cwordPos(I, S, StartPos)
end;

function {TxSearch} WCharPos(const CharsPair, S: string;
  const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload
var
  I: integer;
begin
  I := 0;
  if CharsPair <> '' then
    move(CharsPair[1], I, sizeOf(word));
  if IgnoreCase then
    Result := _icwordPos(I, S, StartPos)
  else
    Result := _cwordPos(I, S, StartPos)
end;

function {TxSearch} WCharPos(const CharsPair, S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload
var
  I: integer;
begin
  I := 0;
  if CharsPair <> '' then
    move(CharsPair[1], I, sizeOf(word));
  if IgnoreCase then
    Result := _icwordPos(I, S, StartPos)
  else
    Result := _cwordPos(I, S, StartPos)
end;

function {TxSearch} WCharCount(const firstChar, secondChar: Char;
  const S: string; const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload
var
  I: integer;
begin
  I := ord(secondChar) shl 8 or ord(firstChar);
  if IgnoreCase then
    Result := _icwordCount(I, S, StartPos)
  else
    Result := _cwordCount(I, S, StartPos)
end;

function {TxSearch} WCharCount(const firstChar, secondChar: Char;
  const S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload
var
  I: integer;
begin
  I := ord(secondChar) shl 8 or ord(firstChar);
  if IgnoreCase then
    Result := _icwordCount(I, S, StartPos)
  else
    Result := _cwordCount(I, S, StartPos)
end;

function {TxSearch} WCharCount(const CharsPair, S: string;
  const IgnoreCase: boolean = FALSE;
  const StartPos: integer = 1): integer; register overload
var
  I: integer;
begin
  I := 0;
  if CharsPair <> '' then
    move(CharsPair[1], I, sizeOf(word));
  if IgnoreCase then
    Result := _icwordCount(I, S, StartPos)
  else
    Result := _cwordCount(I, S, StartPos)
end;

function {TxSearch} WCharCount(const CharsPair, S: string; const StartPos: integer;
  const IgnoreCase: boolean = FALSE): integer; register overload
var
  I: integer;
begin
  I := 0;
  if CharsPair <> '' then
    move(CharsPair[1], I, sizeOf(word));
  if IgnoreCase then
    Result := _icwordCount(I, S, StartPos)
  else
    Result := _cwordCount(I, S, StartPos)
end;

const SPACE = ' ';

function ControlCharPos(const S: string; const StartPos: integer): integer;
assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jg @@notfound
  @_Loop:
    cmp byte ptr[esi], space
    lea esi, esi +1; jb @@found
    inc StartPos; jle @_Loop
  @@notfound: mov esi, S
  @@found: sub esi, S; mov eax, esi
  @@end: pop esi
  @@Stop:
  end;

function PackWords(const table: TCharSetTable; const S: string; const delimiter: char): string;
var
  i, k, Len: integer;
  Buf: pChar;
begin
  Result := S;
  if S <> '' then begin
    Len := length(S);
    if (Len > 0) then begin
      getmem(Buf, len);
      try
        xMove(S[1], buf[0], len);
        i := 1; k := 0;
        repeat
          while (i <= Len) and (table[S[i]] = 0) do
            inc(i);
          while (i <= len) and (table[S[i]] <> 0) do begin
            Buf[k] := S[i];
            inc(i); inc(k);
          end;
          if k < len - 1 then begin
            buf[k] := Delimiter;
            inc(k);
          end;
        until i > Len;
        SetLength(Result, k);
        xMove(buf[0], Result[1], k);
      finally
        freemem(buf);
      end;
    end;
  end;
end;

function PackWordsUpperCase(const table: TCharSetTable; const S: string; const delimiter: char): string;
var
  i, k, Len: integer;
  Buf: pChar;
begin
  Result := S;
  if S <> '' then begin
    Len := length(S);
    if (Len > 0) then begin
      getmem(Buf, len);
      try
        xMove(S[1], buf[0], len);
        i := 1; k := 0;
        repeat
          while (i <= Len) and (table[S[i]] = 0) do
            inc(i);
          while (i <= len) and (table[S[i]] <> 0) do begin
            Buf[k] := S[i];
            inc(i); inc(k);
          end;
          if k < i - 1 then begin
            buf[k] := Delimiter;
            inc(k);
          end;
        until i > Len;
        SetLength(Result, k);
        xMove(buf[0], Result[1], k);
      finally
        freemem(buf);
      end;
    end;
  end;
end;

{
function packWord(const table: TCharSetTable; const S: string; const StartPos: integer; const delimiter: char): string;
//const DELIMITER = ' ';
asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi; push edi; push ebx
    lea esi, S + StartPos -1
    mov ebx, table  // put them here, mov ebx, eax
    sub StartPos, S.SzLen; mov eax, 0; jg @@end
    push ecx                  // ecx = StartPos
    mov eax, Result           // where the result will be stored
    call System.@LStrClr      // cleared for ease
    mov edx, [ESP]            // [esp] is prior ecx value (negative)
    neg edx                   // how much length of str requested
    call System.@LStrSetLength// result: new allocation pointer in EAX
    mov S, [eax]            // eax contains the new allocated pointer -Differ-
    mov edi, [eax]
    mov Result, edi
    pop ecx                   // ecx = StartPos
    xor eax, eax
  @_Loop:
    mov al, [esi]; mov [edi], al
    lea edi, edi +1
    mov eax, ebx + eax*4
    test eax, 1
    lea esi, esi +1; jnz @_ //
    mov al, Delimiter
    cmp [edi-1], al; jnz @_
    dec edi
    mov [edi], al
  @_: inc StartPos; jle @_Loop
    mov eax, Result
    mov edx, eax.SzLen
    sub edi, eax
    cmp edi, edx; jz @@end
    lea eax, Result
    call System.@LStrSetLength
  @@end: pop ebx; pop edi; pop esi
  @@Stop:
end;
}

const HIBIT = $7F;

function AlphaNumCharPos(const S: string; const StartPos: integer; const table): integer;
assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi; push ebx
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jg @@notfound
    mov ebx, table
    xor ecx, ecx
  @_Loop:
    mov cl, byte ptr[esi]
    cmp byte ptr[esi], space
    lea esi, esi +1; jb @@found
    inc StartPos; jle @_Loop
  @@notfound: mov esi, S
  @@found: sub esi, S; mov eax, esi
  @@end: pop ebx; pop esi
  @@Stop:
  end;

function HiBitCharPos(const S: string; const StartPos: integer): integer;
assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; jg @@notfound
  @_Loop:
    cmp byte ptr[esi], hibit
    lea esi, esi +1; ja @@found
    inc StartPos; jle @_Loop
  @@notfound: mov esi, S
  @@found: sub esi, S; mov eax, esi
  @@end: pop esi
  @@Stop:
  end;

function HiBitCharCount(const S: string; const StartPos: integer = 1): integer;
assembler asm
  @@Start:
    test S, S; jz @@zero // check S length
    or StartPos, StartPos; jg @@begin //still need to be checked
  @@zero: xor eax, eax; jmp @@Stop
  @@begin: push esi
    lea esi, S + StartPos -1
    sub StartPos, S.SzLen; mov S, 0; jg @@done
  @_Loop:
    cmp byte ptr[esi], hibit
    lea esi, esi +1; jna @_
    ;inc S
  @_: inc StartPos; jle @_Loop
  @@done: mov eax, S
  @@end: pop esi
  @@Stop:
  end;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// test...
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



const
  _CR = ^m; // $0D
  _LF = ^j; // $0A
  _CRLF = ord(_CR) or (ord(_LF) shr 8); // $0A$0D

function PosCRLF(const S: string; const StartPos: integer = 1): integer;
begin
  //Result := _cWordPos(WideChar(_CRLF), S, StartPos);
  Result := _cWordPos(_CRLF, S, StartPos);
end;

type
  par = ^tar;
  tar = array[0..0] of Char;

function UNIXed(const CRLFText: string): string;
// strip CR from CRLF, CRLF to LF only (unix style)
var
  i, j, k, L: integer;
  Buf: Par;
  S: string;
begin
  Result := CRLFText;
  L := Length(CRLFText);
  if L > 0 then begin
    getMem(Buf, L);
    try
      j := 0; k := 0;
      for i := 1 to ChPos.WordCount(CRLFText, ^m) do begin
        inc(k);
        S := ChPos.WordNth(1, CRLFText, ^m, k);
        L := length(S);
        move(S[1], Buf^[j], L);
        inc(j, L); inc(k, L);
      end;
      if j > 0 then begin
        SetLength(Result, j);
        move(Buf^[0], Result[1], j);
      end;
    finally
      freemem(Buf);
    end;
  end;
end;

// should be faster - untested yet, no time

function UNIXed2(const CRLFText: string): string;
// strip CR from CRLF, CRLF to LF only (unix style)
var
  i, j, k, L: integer;
  Buf: Par;
begin
  Result := CRLFText;
  L := Length(CRLFText);
  if L > 0 then begin
    getMem(Buf, L);
    try
      i := PosCRLF(CRLFText);
      if i > 0 then begin
        j := 1; k := 0;
        while i > 0 do begin
          L := i - j;
          move(CRLFText[j], Buf^[k], L);
          inc(k, L); Buf^[k] := ^j; inc(k);
          j := i + 2;
          i := PosCRLF(CRLFText, j);
        end;
        L := length(CRLFText) - j;
        move(CRLFText[j], Buf^[k], L);

        inc(j, L);
        SetLength(Result, j);
        move(Buf^[0], Result[1], j);
      end;
    finally
      freemem(Buf);
    end;
  end;
end;

function MACed(const CRLFText: string): string;
// strip LF from CRLF, CRLF to CR only (MAC style)
var
  i, j, k, L: integer;
  Buf: Par;
begin
  Result := CRLFText;
  L := Length(CRLFText);
  if L > 0 then begin
    getMem(Buf, L);
    try
      j := 1; k := 0;
      i := PosCRLF(CRLFText);
      if i > 1 then begin
        repeat
          L := i - j - 1; // ecxluding the last-char
          move(CRLFText[j], Buf^[k], L);
          inc(k, L);
          j := i;
          i := PosCRLF(CRLFText, j + 1);
        until i < 1;
      end;
      if j > 1 then begin
        SetLength(Result, j);
        move(Buf^[0], Result[1], j);
      end;
    finally
      freemem(Buf);
    end;
  end;
end;

end.

